// To compile this code:
//    cd "...\lib\java\COM\staticfreesoft"
//    type "javac Electric.java"

package COM.staticfreesoft;


public class Electric
{
	final static public int vdisplay = 64;

	long address;

	public static class NodeInst extends Electric {}
	public static class NodeProto extends Electric {}
	public static class PortArcInst extends Electric {}
	public static class PortExpInst extends Electric {}
	public static class PortProto extends Electric {}
	public static class ArcInst extends Electric {}
	public static class ArcProto extends Electric {}
	public static class Geom extends Electric {}
	public static class Library extends Electric {}
	public static class Technology extends Electric {}
	public static class Tool extends Electric {}
	public static class RTNode extends Electric {}
	public static class Network extends Electric {}
	public static class Cell extends Electric {}
	public static class View extends Electric {}
	public static class WindowPart extends Electric {}
	public static class WindowFrame extends Electric {}
	public static class Graphics extends Electric {}
	public static class Constraint extends Electric {}
	public static class Polygon extends Electric {}
	public static class XArray
	{
		public int[] v;
	}

	public class eout extends java.io.PrintStream
	{
		public eout() { super(System.out); }
		public void takeover() { System.setOut(this); System.setErr(this); }

		public native void ewrite(String s);
		public native void write(int b);

		public boolean checkError()  { return(false); }
		public void flush()          {}
		public void print(boolean b) { ewrite(b ? "true" : "false"); }
		public void print(char c)    { ewrite(String.valueOf(c)); }
		public void print(int i)     { ewrite(String.valueOf(i)); }
		public void print(long l)    { ewrite(String.valueOf(l)); }
		public void print(float f)   { ewrite(String.valueOf(f)); }
		public void print(double d)  { ewrite(String.valueOf(d)); }
		public void print(char s[])  { for (int i = 0; i < s.length; i++) write(s[i]); }
		public void print(String s)  { if (s == null) s = "null"; ewrite(s); }
		public void print(Object o)  { ewrite(String.valueOf(o)); }
		public void println()          {           write('\n'); }
		public void println(boolean x) { print(x); write('\n'); }
		public void println(char x)    { print(x); write('\n'); }
		public void println(int x)     { print(x); write('\n'); }
		public void println(long x)    { print(x); write('\n'); }
		public void println(float x)   { print(x); write('\n'); }
		public void println(double x)  { print(x); write('\n'); }
		public void println(char x[])  { print(x); write('\n'); }
		public void println(String x)  { print(x); write('\n'); }
		public void println(Object x)  { print(x); write('\n'); }
		public void write(byte[] s, int off, int len)
			{ for (int i = 0; i < len; i++) write(s[i+off]); }
	}

	public void setAddress(long a) { address = a; }
	public long getAddress() { return(address); }
	public boolean isNull() { return(address == -1); }
	public static boolean isEqual(Electric a1, Electric a2) { return(a1.address == a2.address); }

	/***************** DATABASE EXAMINATION ROUTINES *****************/
	public static native Library curLib();
	public static native Technology curTech();
	public static native Object getVal(NodeInst obj, String name);
	public static native Object getVal(NodeProto obj, String name);
	public static native Object getVal(PortArcInst obj, String name);
	public static native Object getVal(PortExpInst obj, String name);
	public static native Object getVal(PortProto obj, String name);
	public static native Object getVal(ArcInst obj, String name);
	public static native Object getVal(ArcProto obj, String name);
	public static native Object getVal(Geom obj, String name);
	public static native Object getVal(Library obj, String name);
	public static native Object getVal(Technology obj, String name);
	public static native Object getVal(Tool obj, String name);
	public static native Object getVal(RTNode obj, String name);
	public static native Object getVal(Network obj, String name);
	public static native Object getVal(Cell obj, String name);
	public static native Object getVal(View obj, String name);
	public static native Object getVal(WindowPart obj, String name);
	public static native Object getVal(WindowFrame obj, String name);
	public static native Object getVal(Graphics obj, String name);
	public static native Object getVal(Constraint obj, String name);
	public static native Object getVal(Polygon obj, String name);
	public static native Object getParentVal(String name, Object def, int height);
	public static native void setVal(Object obj, String name, Object attr, int bits);
	public static native void setInd(Object obj, String name, int index, Object attr);
	public static native void delVal(Object obj, String name);
	public static native int initSearch(int lx, int hx, int ly, int hy, NodeProto cell);
	public static native Object nextObject(int search);
	public static native void termSearch(int search);

	/***************** TOOL ROUTINES *****************/
	public static native Tool getTool(String name);
	public static native int maxTool();
	public static native Tool indexTool(int index);
	public static native void toolTurnOn(Tool a);
	public static native void toolTurnOff(Tool a);
	public static native void tellTool(Tool a, int argc, String[] argv);

	/***************** LIBRARY ROUTINES *****************/
	public static native Library getLibrary(String name);
	public static native Library newLibrary(String libname, String libfile);
	public static native void killLibrary(Library lib);
	public static native void eraseLibrary(Library lib);
	public static native void selectLibrary(Library lib);

	/***************** NODEPROTO ROUTINES *****************/
	public static native NodeProto getNodeProto(String name);
	public static native NodeProto newNodeProto(String name, Library lib);
	public static native int killNodeProto(NodeProto cell);
	public static native NodeProto copyNodeProto(NodeProto cell, Library tolibrary,
		String toname);
	public static native NodeProto iconView(NodeProto cell);
	public static native NodeProto contentsView(NodeProto cell);

	/***************** NODEINST ROUTINES *****************/
	public static native NodeInst newNodeInst(NodeProto proto, int lx, int hx,
		int ly, int hy, int trans, int rot, NodeProto cell);
	public static native void modifyNodeInst(NodeInst node, int dlx, int dly,
		int dhx, int dhy, int drot, int dtrans);
	public static native int killNodeInst(NodeInst node);
	public static native NodeInst replaceNodeInst(NodeInst node, NodeProto newproto);
	public static native int nodeFunction(NodeInst node);
	public static native int nodePolys(NodeInst node);
	public static native Electric.Polygon shapeNodePoly(NodeInst node, int index);
	public static native int nodeEPolys(NodeInst node);
	public static native Electric.Polygon shapeENodePoly(NodeInst node, int index);
	public static native Electric.XArray makeRot(NodeInst node);
	public static native Electric.XArray makeTrans(NodeInst node);
	public static native int[] nodeProtoSizeOffset(NodeProto proto);

	/***************** ARCINST ROUTINES *****************/
	public static native ArcInst newArcInst(ArcProto proto, int wid, int bits,
		NodeInst node1, PortProto port1, int x1, int y1,
		NodeInst node2, PortProto port2, int x2, int y2, NodeProto cell);
	public static native int modifyArcInst(ArcInst arc, int dwid, int dx1, int dy1,
		int dx2, int dy2);
	public static native int killArcInst(ArcInst arc);
	public static native ArcInst replaceArcInst(ArcInst arc, ArcProto newproto);
	public static native int arcPolys(ArcInst arc);
	public static native Electric.Polygon shapeArcPoly(ArcInst arc, int index);
	public static native int arcProtoWidthOffset(ArcProto proto);

	/***************** PORTPROTO ROUTINES *****************/
	public static native PortProto newPortProto(NodeProto cell, NodeInst node,
		PortProto port, String name);
	public static native Integer[] portPosition(NodeInst node, PortProto port);
	public static native PortProto getPortProto(NodeProto cell, String name);
	public static native int killPortProto(NodeProto cell, PortProto port);
	public static native int movePortProto(NodeProto cell, PortProto oldport,
		NodeInst newnode, PortProto newport);
	public static native Electric.Polygon shapePortPoly(NodeInst node, PortProto pp);

	/***************** CHANGE CONTROL ROUTINES *****************/
	public static native int undoABatch();
	public static native void noUndoAllowed();
	public static native void flushChanges();

	/***************** VIEW ROUTINES *****************/
	public static native View getView(String name);
	public static native View newView(String name, String shortname);
	public static native int killView(View v);

	/***************** MISCELLANEOUS ROUTINES *****************/
	public static native ArcProto getArcProto(String name);
	public static native Cell getCell(String name);
	public static native Technology getTechnology(String name);
	public static native NodeProto getPinProto(ArcProto arctype);
	public static native Network getNetwork(String name, NodeProto cell);
	public static native String layerName(Technology tech, int layer);
	public static native int layerFunction(Technology tech, int layer);
	public static native int maxDRCSurround(Technology tech, Library lib, int layer);
	public static native int DRCMinDistance(Technology tech, Library lib, int layer1,
		int layer2, int connected);
	public static native int DRCMinWidth(Technology tech, Library lib, int layer);
	public static native void xformPoly(Polygon poly, XArray trans);
	public static native XArray transMult(XArray transa, XArray transb);
	public static native void freePolygon(Polygon poly);
	public static native void beginTraverseHierarchy();
	public static native void downHierarchy(NodeInst node, int index);
	public static native void upHierarchy();
	public static native void endTraverseHierarchy();
	public static native Electric.NodeInst[] getTraversalPath();
}
