/* -*- tab-width: 4 -*- */

#include <ctype.h>

#include "elkkernel.h"

int General_Chrcmp P_((ELKObject c1, ELKObject c2, int ci));

ELKObject Make_Char (register int c) {
	ELKObject ch;

	SET(ch, T_Character, (UCHAR1)c);
	return ch;
}

ELKObject P_Charp (ELKObject c) {
	return TYPE(c) == T_Character ? Trueob : Falseob;
}

ELKObject P_Char_To_Integer (ELKObject c) {
	Check_Type (c, T_Character);
	return Make_Integer (ELKCHAR(c));
}

ELKObject P_Integer_To_Char (ELKObject n) {
	register int i;

	if ((i = Get_Exact_Integer (n)) < 0 || i > 255)
		Range_Error (n);
	return Make_Char (i);
}

ELKObject P_Char_Upper_Casep (ELKObject c) {
	Check_Type (c, T_Character);
	return isupper (ELKCHAR(c)) ? Trueob : Falseob;
}

ELKObject P_Char_Lower_Casep (ELKObject c) {
	Check_Type (c, T_Character);
	return islower (ELKCHAR(c)) ? Trueob : Falseob;
}

ELKObject P_Char_Alphabeticp (ELKObject c) {
	Check_Type (c, T_Character);
	return isalpha (ELKCHAR(c)) ? Trueob : Falseob;
}

ELKObject P_Char_Numericp (ELKObject c) {
	Check_Type (c, T_Character);
	return isdigit (ELKCHAR(c)) ? Trueob : Falseob;
}

ELKObject P_Char_Whitespacep (ELKObject c) {
	register int x;

	Check_Type (c, T_Character);
	x = ELKCHAR(c);
	return Whitespace (x) ? Trueob : Falseob;
}

ELKObject P_Char_Upcase (ELKObject c) {
	Check_Type (c, T_Character);
	return islower (ELKCHAR(c)) ? Make_Char (toupper (ELKCHAR(c))) : c;
}

ELKObject P_Char_Downcase (ELKObject c) {
	Check_Type (c, T_Character);
	return isupper (ELKCHAR(c)) ? Make_Char (tolower (ELKCHAR(c))) : c;
}

int General_Chrcmp (ELKObject c1, ELKObject c2, register int ci) {
	Check_Type (c1, T_Character);
	Check_Type (c2, T_Character);
	if (ci)
		return Char_Map[ELKCHAR(c1)] - Char_Map[ELKCHAR(c2)];
	return ELKCHAR(c1) - ELKCHAR(c2);
}

ELKObject P_Char_Eq (ELKObject c1, ELKObject c2) {
	return General_Chrcmp (c1, c2, 0) ? Falseob : Trueob;
}

ELKObject P_Char_Less (ELKObject c1, ELKObject c2) {
	return General_Chrcmp (c1, c2, 0) < 0 ? Trueob : Falseob;
}

ELKObject P_Char_Greater (ELKObject c1, ELKObject c2) {
	return General_Chrcmp (c1, c2, 0) > 0 ? Trueob : Falseob;
}

ELKObject P_Char_Eq_Less (ELKObject c1, ELKObject c2) {
	return General_Chrcmp (c1, c2, 0) <= 0 ? Trueob : Falseob;
}

ELKObject P_Char_Eq_Greater (ELKObject c1, ELKObject c2) {
	return General_Chrcmp (c1, c2, 0) >= 0 ? Trueob : Falseob;
}

ELKObject P_Char_CI_Eq (ELKObject c1, ELKObject c2) {
	return General_Chrcmp (c1, c2, 1) ? Falseob : Trueob;
}

ELKObject P_Char_CI_Less (ELKObject c1, ELKObject c2) {
	return General_Chrcmp (c1, c2, 1) < 0 ? Trueob : Falseob;
}

ELKObject P_Char_CI_Greater (ELKObject c1, ELKObject c2) {
	return General_Chrcmp (c1, c2, 1) > 0 ? Trueob : Falseob;
}

ELKObject P_Char_CI_Eq_Less (ELKObject c1, ELKObject c2) {
	return General_Chrcmp (c1, c2, 1) <= 0 ? Trueob : Falseob;
}

ELKObject P_Char_CI_Eq_Greater (ELKObject c1, ELKObject c2) {
	return General_Chrcmp (c1, c2, 1) >= 0 ? Trueob : Falseob;
}
