/* -*- tab-width: 4 -*- */

#include "global.h"

#include <string.h>
#include <stdlib.h>

/* Presume that the system supports the vprintf library function. */
#define VPRINTF           1

/* What is the name of the a.out include file? */
#define AOUT_H            x_("<a.out.h>")

/* Presume that the system page size can be determined by calling getpagesize(). */
#define GETPAGESIZE       1

/* Presume that the names of external functions in the symbol table always begin */
/* with a special character (the underline). */
#define SYMS_BEGIN_WITH   '_'

/* The symbol prefixes of extension initialization and finalization */
/* functions (without the initial $syms_begin_with).  Do not change */
/* these unless the compiler or linker restricts the length of symbols! */
#define INIT_PREFIX       x_("elk_init_")
#define FINIT_PREFIX      x_("elk_finit_")

/* Presume that the system requires certain objects (e.g. doubles) */
/* to be aligned at 8-byte boundaries. */
#define ALIGN_8BYTE       1

#define WANT_PROTOTYPES   1
#define ATEXIT            1
#define NOMAIN            1

#define OBJ_DIR           x_(".")
#define MAX_STACK_SIZE    (1024*512)

#ifndef bcopy
#  define bcopy(s,d,c)    memcpy(d,s,c)
#endif

#ifndef bzero
#  define bzero(d, c)     memset(d, 0, c)
#endif

#ifndef bcmp
#  define bcmp(m1, m2, c) memcmp(m1, m2, c)
#endif

#ifndef STDC_HEADERS
#  define STDC_HEADERS
#endif

#ifdef WIN32
#  define HEAP_SIZE       (1024*10)
#  define ELLIPSIS
#endif

#ifdef MACOS
#  define HEAP_SIZE       (1024*2)
#  define index           estrchr
#  define ELLIPSIS ...
#endif

#ifdef ONUNIX
#  define HEAP_SIZE       (1024*10)
#  ifdef USEQT
#    define ELLIPSIS ...
#  else
#    define ELLIPSIS
#  endif
#endif
