/* -*- tab-width: 4 -*- */

/* Functions and variables that are used by more than one source file of
 * the kernel.  Not available to extensions and applications.
 */

C_LINKAGE_BEGIN

/* autoload.c
 */
extern void Init_Auto P_((void));
extern ELKObject V_Autoload_Notifyp;
extern ELKObject Do_Autoload P_((ELKObject, ELKObject));

/* bignum.c
 */
extern void Print_Bignum P_((ELKObject, ELKObject));
extern int Bignum_To_Integer P_((ELKObject));
extern int Bignum_Zero P_((ELKObject));
extern int Bignum_Positive P_((ELKObject));
extern int Bignum_Negative P_((ELKObject));
extern int Bignum_Even P_((ELKObject));
extern ELKObject Make_Bignum P_((const CHAR*, int, int));
extern ELKObject Integer_To_Bignum P_((int));
extern ELKObject Bignum_Divide P_((ELKObject, ELKObject));
extern ELKObject Bignum_Abs P_((ELKObject));
extern ELKObject Bignum_Plus P_((ELKObject, ELKObject));
extern ELKObject Bignum_Minus P_((ELKObject, ELKObject));
extern ELKObject Bignum_Fixnum_Multiply P_((ELKObject, ELKObject));
extern ELKObject Bignum_Multiply P_((ELKObject, ELKObject));
extern ELKObject Bignum_Fixnum_Divide P_((ELKObject, ELKObject));
extern ELKObject Double_To_Bignum P_((double));
extern ELKObject Unsigned_To_Bignum P_((unsigned));
extern ELKObject Long_To_Bignum P_((long));
extern ELKObject Unsigned_Long_To_Bignum P_((unsigned long));
extern unsigned Bignum_To_Unsigned P_((ELKObject));
extern unsigned long Bignum_To_Unsigned_Long P_((ELKObject));
extern long Bignum_To_Long P_((ELKObject));
extern ELKObject Bignum_To_String P_((ELKObject, int));
extern double Bignum_To_Double P_((ELKObject));
extern int Bignum_Equal P_((ELKObject, ELKObject));
extern int Bignum_Greater P_((ELKObject, ELKObject));
extern int Bignum_Less P_((ELKObject, ELKObject));
extern int Bignum_Eq_Less P_((ELKObject, ELKObject));
extern int Bignum_Eq_Greater P_((ELKObject, ELKObject));

/* cont.c
 */
extern WIND *First_Wind, *Last_Wind;
extern ELKObject Internal_Call_CC P_((int, ELKObject));
extern void Do_Wind P_((ELKObject));
extern void Add_Wind P_((WIND *, ELKObject, ELKObject));
extern int Stack_Size P_((void));
extern int Check_Stack_Grows_Down P_((void));

/* cstring.c
 */
extern void Init_Cstring P_((void));

/* dump.c
 */
extern ELKObject Dump_Control_Point;

/* env.c
 */
extern ELKObject Add_Binding P_((ELKObject, ELKObject, ELKObject));
extern ELKObject Lookup_Symbol P_((ELKObject, int));
extern void Switch_Environment P_((ELKObject));
extern void Memoize_Frame P_((ELKObject));
extern void Init_Env P_((void));
extern void Push_Frame P_((ELKObject));
extern void Pop_Frame P_((void));

/* error.c
 */
extern ELKObject Arg_True;
extern CHAR *appname;
extern void Reset P_((void));
extern void Uncatchable_Error P_((CHAR *));
extern void Init_Error P_((void));

/* exception.c
 */
extern void Install_Intr_Handler P_((void));
extern void Init_Exception P_((void));

/* feature.c
 */
extern void Init_Features P_((void));

/* heap.c
 */
#ifndef GENERATIONAL_GC
extern CHAR *Hp, *Heap_Start, *Heap_End, *Free_Start, *Free_End;
#endif
extern int GC_In_Progress;
extern void Init_Heap P_((void));
extern void Make_Heap P_((int));

/* io.c
 */
extern ELKObject General_Open_File P_((ELKObject, int, ELKObject));
extern void Init_Io P_((void));
extern void Close_All_Files P_((void));

/* load.c
 */
extern CHAR *Loader_Input;
extern ELKObject V_Load_Path, V_Load_Noisilyp, V_Load_Libraries;
extern void Check_Loadarg P_((ELKObject));
extern ELKObject General_Load P_((ELKObject, ELKObject));
extern void Init_Load P_((void));
extern void Init_Loadpath P_((CHAR *));

/* list.c
 */
extern ELKObject General_Assoc P_((ELKObject, ELKObject, int));

/* main.c
 */
extern CHAR *stkbase, *A_Out_Name;
extern int Stack_Grows_Down;
extern int Max_Stack, Interpreter_Initialized, Was_Dumped;
extern CHAR *Brk_On_Dump;
extern int Verb_Load, Verb_Init, Case_Insensitive;
extern SYMTAB *The_Symbols;
extern void Exit_Handler P_((void));
#ifndef ATEXIT
extern void exit P_((int));
#endif
extern void Check_If_Dump_Works P_((void));

/* math.c
 */
extern CHAR *Flonum_To_String P_((ELKObject));
extern void Init_Math P_((void));
extern int Get_Index P_((ELKObject, ELKObject));

/* prim.c
 */
extern void Init_Prim P_((void));

/* print.c
 */
extern void Init_Print P_((void));
extern void Flush_Output P_((ELKObject));
extern void Pr_List P_((ELKObject port, ELKObject list, int raw, int depth, int length));
extern void Pr_Vector P_((ELKObject port, ELKObject vec, int raw, int depth, int length));
extern void Print_Char P_((ELKObject port, int c));

/* proc.c
 */
extern ELKObject Sym_Lambda, Sym_Macro;
extern void Funcall_Control_Point P_((ELKObject, ELKObject, int));
extern ELKObject Make_Primitive
	P_((ELKObject(*)(ELLIPSIS), const CHAR*, int, int, enum discipline));
extern void Init_Proc P_((void));

/* read.c
 */
extern ELKObject Sym_Quote;
extern ELKObject Sym_Quasiquote, Sym_Unquote, Sym_Unquote_Splicing;
extern ELKObject Parse_Number P_((ELKObject, const CHAR*, int));
extern void Init_Read P_((void));
extern void Reader_Error P_((ELKObject, CHAR *));
extern void DumpStdOut P_((CHAR *, long));

/* special.c
 */
extern void Init_Special P_((void));

/* stab.c
 */
extern SYMTAB *Snarf_Symbols P_((ELLIPSIS));  /* varying args */
extern SYMTAB *Open_File_And_Snarf_Symbols P_((CHAR *));

/* stkmem.c
 */
#ifndef USE_ALLOCA
extern ELKObject Save_GC_Nodes P_((void));
extern void Save_Mem_Nodes P_((ELKObject));
extern void Free_Mem_Nodes P_((MEM_NODE *));
extern void Restore_GC_Nodes P_((ELKObject));
extern void Restore_Mem_Nodes P_((ELKObject));
#endif

/* string.c
 */
extern CHAR Char_Map[];
extern ELKObject General_Make_String P_((const CHAR*, int, int));
extern void Init_String P_((void));

/* symbol.c
 */
extern ELKObject Unbound, Special, Zero, One;
extern void Init_Symbol P_((void));

/* terminate.c
 */
extern void Init_Terminate P_((void));

/* type.c
 */
extern int Num_Types, Max_Type;
extern void Init_Type P_((void));

/* vector.c
 */
extern ELKObject List_To_Vector P_((ELKObject, int));

C_LINKAGE_END
