/*  -*- tab-width: 4 -*-
 *
 *     ********************************************************************* 
 *     * Copyright (C) 1988, 1990 Stanford University.                     * 
 *     * Permission to use, copy, modify, and distribute this              * 
 *     * software and its documentation for any purpose and without        * 
 *     * fee is hereby granted, provided that the above copyright          * 
 *     * notice appear in all copies.  Stanford University                 * 
 *     * makes no representations about the suitability of this            * 
 *     * software for any purpose.  It is provided "as is" without         * 
 *     * express or implied warranty.                                      * 
 *     ********************************************************************* 
 */
	/* EXPORTS FROM irsimanalyzer.c */
extern int      irsim_AddNode(nptr nd, int *flag);
extern int      irsim_AddVector(bptr vec, int *flag);
extern void     irsim_DisplayTraces(int isMapped);
extern void     irsim_StopAnalyzer(void);
extern void     irsim_RestartAnalyzer(TimeType first_time, TimeType last_time, int same_hist);
extern void     irsim_ClearTraces(void);
extern void     irsim_RemoveVector(bptr b);
extern void     irsim_RemoveNode(nptr n);
extern void     irsim_RemoveAllDeleted(void);
extern void     irsim_UpdateWindow(TimeType endT);
extern void     irsim_TerminateAnalyzer(void);
extern int      irsim_InitDisplay(void);
extern void     irsim_InitTimes(TimeType firstT, TimeType stepsize, TimeType lastT);
extern void     irsim_freeanalyzermemory(void);

	/* EXPORTS FROM irsimbinsim.c */
extern void     irsim_wr_netfile(CHAR *fname);
extern int      irsim_rd_netfile(FILE *f, CHAR *line);
extern nptr     irsim_bin_connect_txtors(void);

	/* EXPORTS FROM irsimconfig.c */
#define	TDIFFCAP	0x1	/* set if DIFFPERIM or DIFFEXTF are true    */
extern double   irsim_CM2A;
extern double   irsim_CM2P;
extern double   irsim_CMA;
extern double   irsim_CMP;
extern double   irsim_CPA;
extern double   irsim_CPP;
extern double   irsim_CDA;
extern double   irsim_CDP;
extern double   irsim_CPDA;
extern double   irsim_CPDP;
extern double   irsim_CGA;
extern double   irsim_CTDW;
extern double   irsim_CPTDW;
extern double   irsim_CTDE;
extern double   irsim_CPTDE;
extern double   irsim_CTGA;
extern double   irsim_LAMBDA;
extern double   irsim_LAMBDA2;
extern long     irsim_LAMBDACM;
extern double   irsim_LOWTHRESH;
extern double   irsim_HIGHTHRESH;
extern double   irsim_DIFFEXT;
extern int      irsim_config_flags;
extern int      irsim_config(CHAR *cname);
extern Resists *irsim_requiv(int type, long width, long length);
extern void     irsim_freeconfigmemory(void);

	/* EXPORTS FROM irsimconn_list.c */
#define	MAX_PARALLEL	30	/* this is probably sufficient per stage */
#define	par_list(T)     (irsim_parallel_xtors[(T)->n_par])
#define	hash_terms(T)	((Ulong)((T)->source) ^ (Ulong)((T)->drain))
extern tptr     irsim_parallel_xtors[/* MAX_PARALLEL */];
extern void     irsim_BuildConnList(register nptr n);
extern void     irsim_WarnTooManyParallel(CHAR *s1, CHAR *s2);

	/* EXPORTS FROM irsimeval.c */
/*
 * simulator can use one of several models, selectable by the user.  Which
 * model to use is kept as index into various dispatch tables, all defined
 * below.
 */
#define	LIN_MODEL	0
#define	SWT_MODEL	1
#define	NMODEL		2		/* number of models supported */
/* compute state of transistor.  If gate is a simple node, state is determined
 * by type of implant and value of node.  If gate is a list of nodes, then
 * this transistor represents a stack of transistors in the original network,
 * and we perform the logical AND of all the gate node values to see if
 * transistor is on.
 */
#define	 compute_trans_state(TRANS)					\
    (((TRANS)->ttype & GATELIST) ?					\
	irsim_ComputeTransState(TRANS):					\
	irsim_switch_state[BASETYPE((TRANS)->ttype)][(TRANS)->gate->npot])
extern void   (*irsim_model_table[/*NMODEL*/])(nptr);
extern int      irsim_model_num;
extern void   (*irsim_model)(nptr);
extern int      irsim_sm_stat;
extern int      irsim_treport;
extern CHAR     irsim_switch_state[/*NTTYPES*/][4];
extern void     irsim_NoInit(void);
extern void     irsim_ReInit(void);
extern int      irsim_step(TimeType stop_time);
extern int      irsim_ComputeTransState(register tptr t);
extern void     irsim_error(CHAR *filename, int lineno, CHAR *fmt, ...);
extern void     irsim_init_eval(void);

	/* EXPORTS FROM irsimfaultsim.c */
extern void     irsim_exec_fsim(CHAR *fname, int p_seed);
extern void     irsim_cleanup_fsim(void);
extern int      irsim_add_trigger(nptr nd, int edge, TimeType delay);
extern int      irsim_add_sampler(TimeType period, TimeType offset);
extern int      irsim_add_prim_output(nptr nd, int *flag);
extern int      irsim_do_trigger(evptr ev);
extern void     irsim_setup_triggers(void);
extern void     irsim_init_faultsim_module(void);

	/* EXPORTS FROM irsimhist.c */
extern hptr     irsim_freeHist;
extern hptr     irsim_last_hist;
extern int      irsim_num_edges;
extern int      irsim_num_punted;
extern int      irsim_num_cons_punted;
extern hptr     irsim_first_model;
extern TimeType irsim_max_time;
extern void     irsim_init_hist(void);
extern void     irsim_SetFirstHist(nptr node, int value, int inp, TimeType time);
extern void     irsim_AddHist(register nptr node, int value, int inp, TimeType time, long delay, long rtime);
extern void     irsim_AddPunted(register nptr node, evptr ev, TimeType tim);
extern void     irsim_FreeHistList(register nptr node);
extern void     irsim_NewModel(int nmodel);
extern void     irsim_NewEdge(nptr nd, evptr ev);
extern void     irsim_DeleteNextEdge(nptr nd);
extern void     irsim_FlushHist(TimeType ftime);
extern int      irsim_backToTime(register nptr nd);

	/* EXPORTS FROM irsimhist_io.c */
extern void     irsim_DumpHist(CHAR *fname);
extern void     irsim_ReadHist(CHAR *fname);

	/* EXPORTS FROM irsimincsim.c */
extern long     irsim_INC_RES;
extern nptr     irsim_inc_cause;
extern long     irsim_nevals;
extern long     irsim_i_nevals;
extern long     irsim_nreval_ev;
extern long     irsim_npunted_ev;
extern long     irsim_nstimuli_ev;
extern long     irsim_ncheckpt_ev;
extern long     irsim_ndelaychk_ev;
extern long	    irsim_ndelay_ev;
extern int	    irsim_fault_mode;
extern void     irsim_incsim(iptr ch_list);
extern void     irsim_init_faultsim(void);
extern void     irsim_end_faultsim(void);
extern void     irsim_faultsim(nptr n);
extern void     irsim_init_incsim(void);

	/* EXPORTS FROM irsimmem.c */
typedef union MElem
{
	union MElem  *next;		/* points to next element in linked list */
	int          align[1];	/* dummy used to force word alignment */
} *MList;
#ifdef DEBUGMEMORY
#  define irsim_MallocList(nb, ne) _irsim_MallocList((nb), (ne), (CHAR *)__FILE__, (INTBIG)__LINE__)
   extern MList    _irsim_MallocList(int nbytes, int no_mem_exit, CHAR *file, INTBIG line);
#else
   extern MList    irsim_MallocList(int nbytes, int no_mem_exit);
#endif

	/* EXPORTS FROM irsimnetupdate.c */
extern iptr     irsim_rd_changes(CHAR *fname, CHAR *logname);

	/* EXPORTS FROM irsimnetwork.c */
#define	FreeInput(X)   (X)->next = irsim_infree, irsim_infree = (X)
extern iptr     irsim_hinputs;
extern iptr     irsim_linputs;
extern iptr     irsim_uinputs;
extern iptr     irsim_xinputs;
extern iptr     irsim_infree;
extern iptr    *irsim_listTbl[/*8*/];
extern void     irsim_init_listTbl(void);
extern void     irsim_idelete(register nptr n, register iptr *list);
extern void     irsim_iinsert(nptr n, iptr *list);
extern void     irsim_iinsert_once(nptr n, iptr *list);
extern void     irsim_ClearInputs(void);
extern int      irsim_setin(register nptr n, CHAR *which);
extern int      irsim_wr_state(CHAR *fname);
extern CHAR    *irsim_rd_state(CHAR *fname, int restore);
extern int      irsim_info(register nptr n, CHAR *which);

	/* EXPORTS FROM irsimnewrstep.c */
extern int      irsim_tunitdelay;
extern TimeType irsim_tdecay;
extern CHAR     irsim_withdriven;
extern void     irsim_linear_model(nptr n);
extern void     irsim_QueueFVal(nptr nd, int fval, double tau, double delay);
extern void     irsim_InitThevs(void);
extern void     irsim_init_newrstep(void);

	/* EXPORTS FROM irsimnsubrs.c */
#define	pnode(NODE)   ((NODE)->nname)
extern CHAR     irsim_vchars[/**/];
extern CHAR    *irsim_ttype[/* NTTYPES */];
extern int      irsim_GetHashSize(void);
extern int      irsim_str_match(register CHAR *p, register CHAR *s);
extern nptr     irsim_find(register CHAR *name);
extern nptr     irsim_GetNode(register CHAR *name);
extern nptr     irsim_GetNewNode(CHAR *name);
extern void     irsim_n_insert(register nptr nd);
extern void     irsim_n_delete(register nptr nd);
extern void     irsim_walk_net(int (*fun)(nptr));
extern void     irsim_walk_net1(int (*fun)(nptr, CHAR*), CHAR *arg);
extern void     irsim_walk_net_index(int (*fun)(nptr, Ulong, FILE*), FILE *arg);
extern nptr     irsim_GetNodeList(void);
extern nptr     irsim_Index2node(Ulong index);
extern Ulong    irsim_Node2index(nptr nd);
extern int      irsim_match_net(CHAR *pattern, int (*fun)(nptr, CHAR*), CHAR *arg);
extern void     irsim_init_hash(void);
extern void     irsim_freensubrsmemory(void);

	/* EXPORTS FROM irsimparallel.c */
extern void     irsim_make_parallel(register nptr nlist);
extern void     irsim_UnParallelTrans(register tptr t);
extern void     irsim_pParallelTxtors(void);

	/* EXPORTS FROM irsimrsim.c */
#define	DEBUG_EV		0x01		/* event scheduling */
#define	DEBUG_DC		0x02		/* final value computation */
#define	DEBUG_TAU		0x04		/* tau/delay computation */
#define	DEBUG_TAUP		0x08		/* taup computation */
#define	DEBUG_SPK		0x10		/* spike analysis */
#define	DEBUG_TW		0x20		/* tree walk */
#define	REPORT_DECAY	0x01
#define	REPORT_DELAY	0x02
#define	REPORT_TAU		0x04
#define	REPORT_TCOORD	0x08
#define REPORT_CAP      0x10
extern CHAR     irsim_version[/**/];
extern int      irsim_contline;
extern int      irsim_analyzerON;
extern TimeType irsim_sim_time0;
extern FILE    *irsim_caplogfile;
extern double	irsim_toggled_cap;
extern float    irsim_vsupply;
extern float    irsim_capstarttime;
extern float    irsim_capstoptime;
extern float	irsim_captime;
extern float	irsim_powermult;
extern int      irsim_pstep;
extern float    irsim_step_cap_x_trans;
extern void     irsim_evalAssertWhen(nptr n);
extern void     irsim_disp_watch_vec(long which);
extern void     irsim_rm_del_from_lists(void);
extern void     irsim_InitCmdPath(void);
extern void     irsim_init_commands(void);
extern void     irsim_freersimmemory(void);
extern void     irsim_issuecommand(CHAR *command, BOOLEAN showcommand);
extern void     irsim_init_rsim(void);

	/* EXPORTS FROM irsimsched.c */
#define free_from_node(ev, nd)					\
{									\
	if ((nd)->events == (ev))						\
		(nd)->events = (ev)->nlink;					\
	else								\
	{									\
		register evptr  evp;						\
		for(evp = (nd)->events; evp->nlink != (ev); evp = evp->nlink);\
			evp->nlink = (ev)->nlink;					\
	}									\
}
#define	FreeEventList(L)	(L)->blink->flink = irsim_evfree, irsim_evfree = (L)
extern int      irsim_debug;
extern TimeType irsim_cur_delta;
extern nptr     irsim_cur_node;
extern long     irsim_nevent;
extern evptr    irsim_evfree;
extern int      irsim_npending;
extern TimeType      irsim_pending_events(TimeType delta, evptr *list, evptr *end_of_list);
extern evptr    irsim_get_next_event(TimeType stop_time);
extern void     irsim_free_event(register evptr event);
extern void     irsim_enqueue_event(register nptr n, int newvalue, long delta, long rtime);
extern void     irsim_enqueue_input(register nptr n, int newvalue);
extern void     irsim_init_event(void);
extern void     irsim_PuntEvent(nptr node, evptr ev);
extern void     irsim_requeue_events(evptr evlist, int thread);
extern evptr    irsim_back_sim_time(TimeType btime, int is_inc);
extern int      irsim_EnqueueHist(nptr nd, hptr hist, int type);
extern void     irsim_DequeueEvent(register nptr nd);
extern void     irsim_DelayEvent(evptr ev, TimeType delay);
extern evptr    irsim_EnqueueOther(int type, TimeType time);
extern void     irsim_rm_inc_events(int all);
extern void     irsim_init_sched(void);

	/* EXPORTS FROM irsimsim.c */
#define	MIN_CAP		0.00001		/* minimum node capacitance (in pf) */
extern nptr     irsim_VDD_node;
extern nptr     irsim_GND_node;
extern lptr     irsim_on_trans;
extern int      irsim_nnodes;
extern int      irsim_naliases;
extern int      irsim_ntrans[/* NTTYPES */];
extern lptr     irsim_freeLinks;
extern tptr     irsim_freeTrans;
extern nptr     irsim_freeNodes;
extern tptr     irsim_tcap;
extern int      irsim_rd_network(CHAR *simfile);
extern void     irsim_pTotalNodes(void);
extern void     irsim_pTotalTxtors(void);
extern void     irsim_ConnectNetwork(void);
extern void     irsim_freesimmemory(void);

	/* EXPORTS FROM irsimsstep.c */
extern void     irsim_switch_model(nptr n);

	/* EXPORTS FROM irsimstack.c */
extern int      irsim_stack_txtors;
extern void     irsim_pStackedTxtors(void);
extern double   irsim_StackCap(register tptr t);
extern void     irsim_make_stacks(nptr nlist);
extern void     irsim_DestroyStack(register tptr stack);
extern void     irsim_PackBytes(void *buff, UINTBIG num, int nbytes);
extern UINTBIG  irsim_UnpackBytes(void *buff, int nbytes);
extern void     irsim_PackTime(void *buff, TimeType type);
extern TimeType irsim_UnpackTime(void *buff);
extern void     irsim_init_stack(void);

	/* EXPORTS FROM irsimsubckt.c */
extern void     irsim_init_subs(void);
extern ufun     irsim_subckt_instantiate(CHAR *sname, ufun *initfunP, int *instP);
extern void     irsim_subckt_model_C(tptr t);

	/* EXPORTS FROM irsimtpos.c */
extern int      irsim_txt_coords;
extern void     irsim_EnterPos(tptr tran, int is_pos);
extern tptr     irsim_FindTxtorPos(register long x, register long y);
extern void     irsim_DeleteTxtorPos(tptr tran);
extern nptr     irsim_FindNode_TxtorPos(CHAR *s);
extern void     irsim_walk_trans(void (*func)(tptr));
extern void     irsim_init_tpos(void);
